program testver;

type

 PLista = ^Lista;
 Lista = Object
  Private
   Nastepny : PLista;

  Public
   Constructor Init;
   procedure Dodaj(aNastepny : PLista);
   Destructor Done;
 end;

 PSLista = ^SLista;
 SLista = Object
  Protected
   Nastepny : PSLista;
   Element  : Pointer;
  Public
   Constructor Init(var aElement : Pointer);
   procedure Dodaj(aNastepny : PSLista);
   procedure Usun(obiekt : PSLista);
   function Porownaj(Element1 : Pointer; Element2 : Pointer) : Integer; virtual; abstract;
   Destructor Done; virtual; abstract;
  end;

 PWLista = ^WLista;
 WLista = Object (SLista)
  Public
   function Porownaj(Element1 : Pointer; Element2 : Pointer) : Integer; virtual;
   procedure Drukuj;
   Destructor Done; virtual;
  end;

function WLista.Porownaj(Element1 : Pointer; Element2 : Pointer) : Integer;
 begin
  if Integer(Element1^)<Integer(Element2^) Then Porownaj:=1
   else
    if Integer(Element1^)>Integer(Element2^) Then Porownaj:=-1
     else Porownaj:=0;
 end;

procedure WLista.Drukuj;
 begin
  Writeln(Integer(Element^));
  if Nastepny<>NIL Then PWLista(Nastepny)^.Drukuj;
 end;

Destructor WLista.Done;
 var
  e : ^Integer;
 begin
  if Nastepny<>NIL Then Nastepny^.Done
   else
    begin
     e:=Element;
     Dispose(e);
    end;
 end;


Constructor SLista.Init(var aElement : Pointer);
 begin
  Nastepny:=NIL; Element:=aElement;
 end;

procedure SLista.Dodaj(aNastepny : PSLista);
 var
  Lista : PSLista;
  p : Integer = 1;
 begin
  Lista:=@self;
  While (Lista^.Nastepny<>NIL) AND (p=1) DO
  begin
   p:=Porownaj(Lista^.Nastepny^.Element,aNastepny^.Element);
   if p<1 Then
    begin
     aNastepny^.Nastepny:=Lista^.Nastepny;
     Lista^.Nastepny:=aNastepny;
    end;
   Lista:=Lista^.Nastepny;
  end;
  if (p=1) AND (Lista^.Nastepny=NIL) Then Lista^.Nastepny:=aNastepny;
 end;

procedure SLista.Usun(obiekt : PSLista);
 var
  Lista : PSLista;
 begin
  Lista:=@self;
  While (Lista^.Nastepny<>NIL) AND (Lista^.Nastepny<>obiekt)
   Do Lista:=Lista^.Nastepny;
   if Lista^.Nastepny=obiekt Then
    begin
     Lista^.Nastepny:=Lista^.Nastepny^.Nastepny;
     Obiekt^.Nastepny:=NIL;
     Dispose(obiekt);
    end;
 end;


Constructor Lista.Init;
 begin
  Nastepny:=NIL;
 end;

procedure Lista.Dodaj(aNastepny : PLista);
 begin
  if Nastepny=NIL Then Nastepny:=aNastepny
   else Nastepny^.Dodaj(aNastepny);
 end;

Destructor Lista.Done;
 begin
 end;


var
 L, L1 : PLista;
 P,p1 : PWLista;
 a : ^Integer;

begin
 new(L,Init);
 new(L1,Init);
 L^.Dodaj(L1);
 new(L1,Init);
 L^.Dodaj(L1);

 //Przykladowe wykorzystanie stworzonych obiektow
 new(a); a^:=-1;
 new(P,Init(a));
 new(a); a^:=4;
 new(p1,Init(a)); P^.Dodaj(p1);
 new(a); a^:=3;
 new(p1,Init(a)); P^.Dodaj(p1);
 new(a); a^:=6;
 new(p1,Init(a)); P^.Dodaj(p1);

 P^.Drukuj;
 P^.Usun(p1);
 P^.Drukuj;
 Dispose(P);

end.
